>From 961b0138dbc0f5e6af1195f61e36a42ad67baaa7 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Sat, 18 Feb 2017 09:59:30 +0100
Subject: [PATCH] Reorganized PKI UI pages.

Previously the index.jsp of the ROOT web application was storing
PKI UI main page which contains links to PKI subsystems installed
on the instance.

Now the file has been changed to redirect to /pki which provides
a new PKI UI welcome page. The PKI UI main page itself has been
moved to /pki/ui.

https://fedorahosted.org/pki/ticket/2582
---
 base/server/share/webapps/ROOT/index.jsp           | 164 +--------------------
 base/server/share/webapps/{ROOT => pki}/index.jsp  |  82 ++---------
 .../share/webapps/{ROOT => pki/ui}/index.jsp       |   0
 3 files changed, 13 insertions(+), 233 deletions(-)
 copy base/server/share/webapps/{ROOT => pki}/index.jsp (56%)
 copy base/server/share/webapps/{ROOT => pki/ui}/index.jsp (100%)

diff --git a/base/server/share/webapps/ROOT/index.jsp b/base/server/share/webapps/ROOT/index.jsp
index ade01bc9e29419c725651546059dc0350afa0084..61f5838fed77e3ca958d37fe94f0a9c5134e7322 100644
--- a/base/server/share/webapps/ROOT/index.jsp
+++ b/base/server/share/webapps/ROOT/index.jsp
@@ -1,165 +1,3 @@
-<!-- --- BEGIN COPYRIGHT BLOCK ---
-     This program is free software; you can redistribute it and/or modify
-     it under the terms of the GNU General Public License as published by
-     the Free Software Foundation; version 2 of the License.
-
-     This program is distributed in the hope that it will be useful,
-     but WITHOUT ANY WARRANTY; without even the implied warranty of
-     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-     GNU General Public License for more details.
-
-     You should have received a copy of the GNU General Public License along
-     with this program; if not, write to the Free Software Foundation, Inc.,
-     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-
-     Copyright (C) 2012 Red Hat, Inc.
-     All rights reserved.
-     --- END COPYRIGHT BLOCK --- -->
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
-<html>
-<head>
-<script type="text/javascript" language="JavaScript" src="/pki/js/jquery.js"></script>
-<script type="text/javascript" language="JavaScript" src="/pki/js/jquery.i18n.properties.js"></script>
-
-<script type="text/javascript" language="JavaScript">
-$(function() {
-    $.i18n.properties({
-        name: 'pki',
-        language: ' ', // suppress potential 404's due to .i18n.browserLang()
-        path: '/pki/',
-        mode: 'map',
-        callback: function() {
-            var key;
-            for (key in $.i18n.map) {
-                var message = $.i18n.prop(key);
-                $('span.message[name='+key+']').html(message);
-            }
-        }
-    });
-});
-</script>
-
-<title>Certificate System</title>
-<meta http-equiv=Content-Type content="text/html; charset=UTF-8">
-<link rel="shortcut icon" href="/pki/images/favicon.ico" />
-<link rel="stylesheet" href="/pki/css/pki-base.css" type="text/css" />
-</head>
-<body bgcolor="#FFFFFF" link="#666699" vlink="#666699" alink="#333366">
-
-<div id="header">
-    <span class="message" name="logo">
-    <a href="http://pki.fedoraproject.org/" title="Visit pki.fedoraproject.org for more information about Certificate System products and services"><img src="/pki/images/logo_header.gif" alt="Certificate System" id="myLogo" /></a>
-    </span>
-    <div id="headertitle">
-    <span class="message" name="title">
-    <a href="/" title=Certificate System">Certificate System</a>
-    </span>
-    </div>
-    <div id="account">
-          <dl><dt><span></span></dt><dd></dd></dl>
-    </div>
-</div>
-
-<div id="mainNavOuter" class="pki-ee-theme">
-<div id="mainNav">
-<div id="mainNavInner">
-
-</div><!-- end mainNavInner -->
-</div><!-- end mainNav -->
-</div><!-- end mainNavOuter -->
-
-
-<div id="bar">
-
-<div id="systembar">
-<div id="systembarinner">
-
-<div>
-  -
-</div>
-
-
-</div>
-</div>
-
-</div>
-
-<center>
-
-<br>
-
-<table border="0" cellspacing="0" cellpadding="0">
-<tr valign="TOP">
-    <td>
 <%
-    ServletContext caContext = getServletContext().getContext("/ca");
-    if (caContext != null) {
-        String caName = caContext.getServletContextName();
-        String caPath = caContext.getContextPath();
-        if (!"".equals(caPath)) {
+    response.sendRedirect("/pki");
 %>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/ca"><%= caName %></a></font>
-<%
-        }
-    }
-
-    ServletContext kraContext = getServletContext().getContext("/kra");
-    if (kraContext != null) {
-        String kraName = kraContext.getServletContextName();
-        String kraPath = kraContext.getContextPath();
-        if (!"".equals(kraPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/kra"><%= kraName %></a></font>
-<%
-        }
-    }
-
-    ServletContext ocspContext = getServletContext().getContext("/ocsp");
-    if (ocspContext != null) {
-        String ocspName = ocspContext.getServletContextName();
-        String ocspPath = ocspContext.getContextPath();
-        if (!"".equals(ocspPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/ocsp"><%= ocspName %></a></font>
-<%
-        }
-    }
-
-    ServletContext tksContext = getServletContext().getContext("/tks");
-    if (tksContext != null) {
-        String tksName = tksContext.getServletContextName();
-        String tksPath = tksContext.getContextPath();
-        if (!"".equals(tksPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/tks"><%= tksName %></a></font>
-<%
-        }
-    }
-
-    ServletContext tpsContext = getServletContext().getContext("/tps");
-    if (tpsContext != null) {
-        String tpsName = tpsContext.getServletContextName();
-        String tpsPath = tpsContext.getContextPath();
-        if (!"".equals(tpsPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/tps/"><%= tpsName %></a></font>
-<%
-        }
-    }
-%>
-    </td>
-</tr>
-</table>
-
-</center>
-
-<div id="footer">
-</div>
-
-</body>
-</html>
diff --git a/base/server/share/webapps/ROOT/index.jsp b/base/server/share/webapps/pki/index.jsp
similarity index 56%
copy from base/server/share/webapps/ROOT/index.jsp
copy to base/server/share/webapps/pki/index.jsp
index ade01bc9e29419c725651546059dc0350afa0084..8eb58546947d1a167c5f87fd23b296d2aa6b1cbc 100644
--- a/base/server/share/webapps/ROOT/index.jsp
+++ b/base/server/share/webapps/pki/index.jsp
@@ -18,8 +18,10 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
+<link href="/pki/css/patternfly.css" rel="stylesheet" media="screen, print">
 <script type="text/javascript" language="JavaScript" src="/pki/js/jquery.js"></script>
 <script type="text/javascript" language="JavaScript" src="/pki/js/jquery.i18n.properties.js"></script>
+<script type="text/javascript" language="JavaScript" src="/pki/js/bootstrap.js"></script>
 
 <script type="text/javascript" language="JavaScript">
 $(function() {
@@ -84,79 +86,19 @@ $(function() {
 
 </div>
 
-<center>
 
-<br>
+<div class="col-lg-7">
+<p>
+The <span class="message" name="title">Certificate System</span> is an enterprise-class open source Certificate Authority (CA).
+It is a full-featured system, and has been hardened by real-world deployments.
+It supports all aspects of certificate lifecycle management, including key archival, OCSP and smartcard management, and much more.
+</p>
 
-<table border="0" cellspacing="0" cellpadding="0">
-<tr valign="TOP">
-    <td>
-<%
-    ServletContext caContext = getServletContext().getContext("/ca");
-    if (caContext != null) {
-        String caName = caContext.getServletContextName();
-        String caPath = caContext.getContextPath();
-        if (!"".equals(caPath)) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/ca"><%= caName %></a></font>
-<%
-        }
-    }
+<p>
+<b><font size="+2"><a name="enter" href="/pki/ui/">Enter</a></font></b>
+</p>
 
-    ServletContext kraContext = getServletContext().getContext("/kra");
-    if (kraContext != null) {
-        String kraName = kraContext.getServletContextName();
-        String kraPath = kraContext.getContextPath();
-        if (!"".equals(kraPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/kra"><%= kraName %></a></font>
-<%
-        }
-    }
-
-    ServletContext ocspContext = getServletContext().getContext("/ocsp");
-    if (ocspContext != null) {
-        String ocspName = ocspContext.getServletContextName();
-        String ocspPath = ocspContext.getContextPath();
-        if (!"".equals(ocspPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/ocsp"><%= ocspName %></a></font>
-<%
-        }
-    }
-
-    ServletContext tksContext = getServletContext().getContext("/tks");
-    if (tksContext != null) {
-        String tksName = tksContext.getServletContextName();
-        String tksPath = tksContext.getContextPath();
-        if (!"".equals(tksPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/tks"><%= tksName %></a></font>
-<%
-        }
-    }
-
-    ServletContext tpsContext = getServletContext().getContext("/tps");
-    if (tpsContext != null) {
-        String tpsName = tpsContext.getServletContextName();
-        String tpsPath = tpsContext.getContextPath();
-        if (!"".equals(tpsPath) && request.isSecure()) {
-%>
-        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
-        <a href="/tps/"><%= tpsName %></a></font>
-<%
-        }
-    }
-%>
-    </td>
-</tr>
-</table>
-
-</center>
+</div>
 
 <div id="footer">
 </div>
diff --git a/base/server/share/webapps/ROOT/index.jsp b/base/server/share/webapps/pki/ui/index.jsp
similarity index 100%
copy from base/server/share/webapps/ROOT/index.jsp
copy to base/server/share/webapps/pki/ui/index.jsp
-- 
2.9.3